#include "H/Function_Init.H"

//ѡһģʽ
#define  Uart1  0
#define  TWI    1
#define  SPI    2

#define  SSI_Mode  SPI
#define SPI_Mode 0 //0:ģʽ   1ӻģʽ
void Uart1_Init(uint Freq,unsigned long int baud);
void TWI_Init(void);
void SPI_Init(void);

bit Uart1SendFlag = 0;    //Uartжϱ־λ
bit Uart1ReceiveFlag = 0; //Uartжϱ־λ
bit SPIFlag = 0;          //SPIݴɱ־λ
bit TWIFlag = 0;          //жϱ־λ
uint8_t TxXferCount = 0;  //SPI/TWIĿ
uint8_t RxXferCount = 0;  //SPI/TWIĿ
uint8_t Uart1_RxData[5];
uint8_t SPI1_Master_SendData[8] = {0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08};
volatile uint8_t SPI1_Slaver_ReceiveData[8];
volatile uint8_t TWI_Slaver_ReceiveData[8]=0;
/*****************************************************
*ƣvoid SSI_Test(void)
*ܣSSI
*ڲvoid
*ڲvoid
*****************************************************/
void SSI_Test(void)
{
#if (SSI_Mode == Uart1)
	int num1,num2;
	Uart1_Init(12,9600);
	while(1)
	{
	for(num1=0;num1<5;num1++)
			{
				while(!Uart1ReceiveFlag);
				Uart1ReceiveFlag = 0;
				Uart1_RxData[num1] = SSDAT ;
			}
			for(num2=0;num2<5;num2++)
			{
				SSDAT  = Uart1_RxData[num2];
				while(!Uart1SendFlag);
				Uart1SendFlag = 0;
			}
	}
#endif
	
#if (SSI_Mode == TWI)
	TWI_Init();
	while(1)
	{
		while((0x07 & SSCON0)!=0x02);//жΪ״̬

			/* ݹ */
		do
		{
		
			while(TWIFlag == 0);
			TWIFlag = 0;  
			TWI_Slaver_ReceiveData[RxXferCount] = SSDAT;             //TWI
			if(TWI_Slaver_ReceiveData[0]==0x01)
			RxXferCount++; 
		}  while(RxXferCount < 8);
    SSCON0 |= 0X08; //AAʹλ
		RxXferCount =0;
		while((0x07 & SSCON0)!=0x00);
	}
#endif

#if (SSI_Mode == SPI)
	SPI_Init();
	while(1)
	{
	#if (SPI_Mode == 0)  //
				TxXferCount = 0;
				while(TxXferCount <  8)//жǷ
				{
				 
					SSDAT = SPI1_Master_SendData[TxXferCount];
					while(!SPIFlag);
		      SPIFlag = 0;	
					TxXferCount ++;	//
				}
				{  int time = 1000;
            while(time--);
        }
#endif
#if (SPI_Mode == 1)  //ӻ
			while(RxXferCount <8)
				{
					/* ȴSPIжϱ־λ */
					while(!SPIFlag);
	      	SPIFlag = 0;	
					SPI1_Slaver_ReceiveData[RxXferCount] = SSDAT;			//ȡ
					RxXferCount++;	//1       
				}
				RxXferCount = 0;
				{  int time = 100;
           while(time--);
        }

#endif
	
	}
#endif	
}
/*****************************************************
*ƣvoid Uart1_Init(uint Freq,unsigned long int baud)
*ܣUart1жϳʼ
*ڲFreq-Ƶbaud-
*ڲvoid
*****************************************************/
void Uart1_Init(uint Freq,unsigned long int baud)
{
	P2CON &= 0xFC;   //TX/RXΪ
	P2PH  |= 0x03;
	
	OTCON |= 0xC0;    //нӿSSIѡUart1ͨ
	SSCON0 = 0x50;   //ͨŷʽΪģʽһ
	SSCON1 = Freq*1000000/baud;   //ʵλ
	SSCON2 = (Freq*1000000/baud)>>8;   //ʸλ
	IE1 |= 0x01;      //SSIж
  EA = 1;	
}

/*****************************************************
*ƣvoid TWI_Init(void)
*ܣTWIʼ
*ڲvoid
*ڲvoid
*****************************************************/
void TWI_Init(void)
{
	OTCON |= 0x80;  //ѡTWIģʽ
	SSCON1 = 0x02;  //xxxx xxxy  xΪַĴyΪ0ֹ/1ͨõַӦ
	SSCON0 = 0x88;  // ---- x---  0Ϊգ1Ϊ
	IE1 |= 0x01;
	EA = 1;
}

/*****************************************************
*ƣvoid SPI_Init(void)
*ܣSPIʼ
*ڲvoid
*ڲvoid
*****************************************************/
void SPI_Init(void)
{
	OTCON |= 0X40;  //ѡSPIģʽ
#if (SPI_Mode == 0)	
 {  SSCON0 = 0x2F; }   //SPIΪ豸SCKʱΪ͵ƽSCKڵڶزɼݣʱΪFsys/512  
#elif (SPI_Mode == 1)	
 {  SSCON0 = 0x0F;   }   //SPIΪ豸SCKʱΪ͵ƽSCKڵڶزɼݣʱΪFsys/512  
#endif 	
	SSCON1 = 0x00;   //ж
	SSCON0 |= 0x80; //SPI
	IE1 |= 0x01;
	EA = 1;
}


/*****************************************************
*ƣvoid TWI/SPI/UART1_Int() interrupt 7
*ܣSSIжϺ
*ڲvoid
*ڲvoid
*****************************************************/
#if (SSI_Mode == Uart1)
void Uart1_Int() interrupt 7   //Uart1жϺ
{
	if(SSCON0&0x02)    //ͱ־λж
	{
		SSCON0 &= 0xFD;
		Uart1SendFlag = 1;
	}
	if((SSCON0&0x01))  //ձ־λж
	{
		SSCON0 &= 0xFE;
		Uart1ReceiveFlag = 1;
	}	
}
#endif

#if (SSI_Mode == TWI)
void TWI_Int() interrupt 7     //TWIжϺ
{
	if(SSCON0&0x40)
	{
		SSCON0 &= 0xbf;  //ж
		TWIFlag = 1;
	}	
}
#endif 

#if (SSI_Mode == SPI)
void SpiInt(void) interrupt 7    //SPIжϺ
{	  
	if(SSCON1&0X08)    //ͻձ־ж
	{
		SSCON1 &= ~0X08;
	}
	if(SSCON1&0X80)    //ݴ־λж
	{
		SSCON1 &= ~0X80;
		SPIFlag = 1;
	}
}
#endif 