//************************************************************
//  Copyright (c) Ԫ΢ӹɷ޹˾
//	ļ	: IAP_Option_EW.h
//			  : AE TEAM
//	ģ鹦	: IAP̼⺯ͷļ
//	ֲб:
//  : 2025/4/28
// 	汾		  : V1.1.2
//  ˵      :ļSC92F841xBϵоƬ
//*************************************************************
#ifndef _IAP_OPTION_EW_H_
#define	_IAP_OPTION_EW_H_

typedef enum{
	IAP_ENABLE =0x69,
	IAP_DISABLE=0x00,
}IAPOPTION_FLAG;

extern unsigned char IapWriteFlag;

/** @brief CPU Hold Time Duration Configuration
 * @{
 */
typedef enum
{
  CPU_Hold_4ms = (unsigned char)(0x00U << 2), /*!< CPU Hold 4ms */
  CPU_Hold_2ms = (unsigned char)(0x01U << 2), /*!< CPU Hold 2ms */
  CPU_Hold_1ms  = (unsigned char)(0x02U << 2), /*!< CPU Hold 1ms */
} CPU_HoldTime_TypeDef;

/**************************************************
*ƣvoid IAP_CodeProgramByteOption(unsigned long Add, unsigned char Data, CPU_HoldTime_TypeDef CPU_HoldTime)
*ܣByteд
*ڲAdd Ҫдĵַ
*          DataҪдByte
*ڲvoid
**************************************************/
void IAP_CodeProgramByteOption(unsigned long Add, unsigned char Data);


/**************************************************
*ƣvoid IAP_EEPROMProgramByteOption(unsigned int Add, unsigned char Data, CPU_HoldTime_TypeDef CPU_HoldTime)
*ܣByteд
*ڲAdd Ҫдĵַ
*          DataҪдByte 
*ڲvoid
**************************************************/
void IAP_EEPROMProgramByteOption(unsigned int Add, unsigned char Data);


/**************************************************
*ƣvoid CPU_HoldTime_Config(CPU_HoldTime_TypeDef CPU_HoldTime)
*ܣCPU HoldTime
*ڲCPU_HoldTimeCPU Hold Time
*         For EEPROM IAP operations, you can choose 2ms or 4ms.
*                  - CPU_Hold_4msCPU Hold 4ms
*                  - CPU_Hold_2ms: CPU Hold 2ms
*                  - CPU_Hold_1ms: CPU Hold 1ms  
*ڲvoid
**************************************************/
void CPU_HoldTime_Config(CPU_HoldTime_TypeDef CPU_HoldTime);

#endif