#ifndef _Function_Init_H_
#define _Function_Init_H_

#include "SC92F841xB_C.H"
#include "intrins.H"
#include "Multiplication_Division.H"
#define uchar unsigned char
#define uint unsigned int
typedef unsigned          char uint8_t;
typedef unsigned short     int uint16_t;
typedef unsigned           int uint32_t;
#define IapROM  0x00	  //0x00ѡROM  0x02ѡEEPROM
#define IapEPPROM  0x02	  //0x00ѡROM  0x02ѡEEPROM

extern void IO_Init(void);
extern void BTM_Test(void);
extern void EXTI_Test(void);
extern void Timer_Test(void);
extern void LCD_Test(void);
extern void PWM_Test(void);
extern void Uart0_Test(void);
extern void SSI_Test(void);
extern void ADC_Test(void);
extern void IAP_Test(void);
extern void Multiplier_Divider_Test(void);
/*****************************************
˵ѡIC
*****************************************/
#define SC92F8413B  0
#define SC92F8419B  1
#define SC92F8412B  2
#define SC92F8411B  3

#define IC_MODEL  SC92F8413B

#endif